/* Marmote is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Marmote is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Marmote. If not, see <http://www.gnu.org/licenses/>.

Copyright 2015 Alain Jean-Marie, Jean-Michel Fourneau, Jean-Marc Vincent, Issam Rabhi */

#include "transitionStructure.h"


bool transitionStructure::readEntry(FILE *input)
{
  double	val;
  int		row;
  int		col;

  if ( 3 == fscanf( input, "%d %d %lf", &row, &col, &val ) ) {
    return setEntry( row, col, val );
  }
  else {
    return false;
  }
}

// Default implementation of the consolidation procedure. Assumes that the
// matrix is full as a worst-case.
// Is destined to be reimplemented for specific structures.
int transitionStructure::consolidate(int i, int *destinations, double *values)
{
  int res = _size;
  for ( int j = 0; j < _size; j++ ) {
    destinations[j] = j;
    values[j] = getEntry(i,j);
  }

  return res;
}
